unit UFrmPlug;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Menus;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    PluginMenu1: TMenuItem;
    ListBox1: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Dclarations prives }
    PlugList:TList;
    procedure PluginClick(Sender:TObject);
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
 uses UGestPlug;

procedure TForm1.FormCreate(Sender: TObject);
var
  Path :string;
  SearchRec:TSearchRec;
  PlugIn :TPlugIn;
  Menu :TMenuItem;
begin
// La liste des plugins chargs
  PlugList:=TList.Create;
// Le rpertoire contenant les plugins
  Path:=ExtractFilePath(Application.ExeName);
// Recherche toutes les DLL
  if FindFirst(Path+'*.DLL',faAnyFile,SearchRec)=0 then
  begin
    repeat
      ListBox1.Items.Add(SearchRec.Name);
    try
// On essaye d'en faire un Plugin
      PlugIn:=TPlugIn.Create(SearchRec.Name);
      Menu:=NewItem(PlugIn.Instance.Caption,PlugIn.Instance.ShortCut,False, True,PlugInClick, 0, '');
      // faire le lien entre le TMenuItem et le TPlugIn
      Menu.Tag:=PlugList.Add(Plugin);
      Menu.Bitmap.Handle:=PlugIn.Instance.Bitmap;
      PluginMenu1.Add(Menu);
    except
      on e:Exception do ListBox1.Items.Add(e.Message);
    end;
  until FindNext(SearchRec)<>0;
  end;
  FindClose(SearchRec);
end;

procedure TForm1.PluginClick(Sender:TObject);
begin
// PlugIn.Instance.DoClick
end;
procedure TForm1.FormDestroy(Sender: TObject);
var
  i:integer;
begin
  // libration de tous les plugins
  for i:=0 to PlugList.Count-1 do
    TPlugin(PlugList[i]).Free;
  PlugList.Free;
end;

end.


