unit UIPlug;

interface
uses Classes;
Type
  IPlugin=interface
    procedure DoClick; stdcall;
    function Caption:pchar; stdcall;
    function ShortCut:TShortCut; stdcall;
    function Bitmap:THandle; stdcall;
  end;

  TIPlugin=class(TInterfacedObject,IPlugin)
  private
    fCaption :string;
    fShortCut:TShortCut;
    fBitmap :THandle;
    public
    Constructor Create(ACaption:string; AShortCut:TShortCut; ABitmap:THandle);
    // interface IPlugin
    procedure DoClick; stdcall;
    function Caption:pchar; stdcall;
    function ShortCut:TShortCut; stdcall;
    function Bitmap:THandle; stdcall;
  end;

implementation
  Uses Dialogs;

  Constructor TIPlugin.Create(ACaption:string; AShortCut:TShortCut; ABitmap:THandle);
  begin
    inherited Create;
    fCaption:=ACaption;
    fShortCut:=AShortCut;
    fBitmap:=ABitmap;
  end;

  procedure TIPlugin.DoClick;
  begin
    ShowMessage('Clicked on '+fCaption);
  end;
  function TIPlugin.Caption:pchar;
  begin
    Result:=PChar(fCaption);
  end;
  function TIPlugin.ShortCut:TShortCut;
  begin
    Result:=fShortCut;
  end;
  function TIPlugin.Bitmap:THandle;
  begin
    Result:=fBitmap;
  end;

end.
